# EllipsisNotation.jl

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/EllipsisNotation/stable/)

[![codecov](https://codecov.io/gh/SciML/EllipsisNotation.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/SciML/EllipsisNotation.jl)
[![Build Status](https://github.com/SciML/EllipsisNotation.jl/workflows/CI/badge.svg)](https://github.com/SciML/EllipsisNotation.jl/actions?query=workflow%3ACI)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

This implements the notation `..` for indexing arrays. It's similar to the Python
`...` in that it means "all the columns before (or after)".

# Installation

```julia
Pkg.add("EllipsisNotation")
using EllipsisNotation
```

# Example Usage

```julia
julia> A = Array{Int}(undef, 2, 4, 2)

julia> A[.., 1] = [2 1 4 5
                   2 2 3 6]

julia> A[.., 2] = [3 2 6 5
                   3 2 6 6]

julia> A[:, :, 1] == [2 1 4 5
                      2 2 3 6]
true

julia> A[1, ..] = reshape([3 4
                           5 6
                           4 5
                           6 7], 1, 4, 2) # drops singleton dimension

julia> B = [3 4
            5 6
            4 5
            6 7]

julia> B == reshape(A[1, ..], 4, 2)
true

julia> A[.., 1, 2] # Can do as many integers as you want on the end!

```

For avoiding squeezing dimensions from slicing.

```julia
julia> C = ones(3, 3, 3, 3, 3);

julia> size(C[1:1, .., 1:1])
(1, 3, 3, 3, 1)
```

Note: `..` slurps dimensions greedily, meaning that the first occurrence
of `..` in an index expression creates as many slices as possible. Other
instances of `..` afterward are treated simply as slices. Usually, you
should only use one instance of `..` in an indexing expression to avoid
possible confusion.

**Warning:** `..` does not work when indexing also with `end` or `begin`.
For example, `A = randn(2,3,4); A[.., 1:end]` will not give the intended
result. This is a known limitation, and is not likely to be fixed until
some necessary changes in the Julia language itself are implemented. See
https://github.com/ChrisRackauckas/EllipsisNotation.jl/issues/19
for more details.

# Acknowledgements

I would like to acknowledge M. Schauer for the `..` notation implementation.
He had the original idea, I just extended it and put it into a package because
of how useful it has been to me.

using Documenter, EllipsisNotation

include("pages.jl")

makedocs(
    sitename = "EllipsisNotation.jl",
    authors = "Chris Rackauckas",
    modules = [EllipsisNotation],
    clean = true, doctest = false, linkcheck = true,
    format = Documenter.HTML(
        assets = ["assets/favicon.ico"],
        canonical = "https://docs.sciml.ai/EllipsisNotation/stable/"
    ),
    pages = pages
)

deploydocs(repo = "github.com/SciML/EllipsisNotation.jl.git"; push_preview = true)

using SafeTestsets

const GROUP = get(ENV, "GROUP", "All")

if GROUP == "All" || GROUP == "Core"
    @time @safetestset "Quality Assurance" include("qa.jl")
    @time @safetestset "Explicit Imports" include("explicit_imports.jl")
    @time @safetestset "Basic Tests" include("basic.jl")
    @time @safetestset "Generic Tests" include("more_generic.jl")
    @time @safetestset "Cartesian Tests" include("cartesian.jl")
end

if GROUP == "nopre"
    @time @safetestset "Allocation Tests" include("alloc_tests.jl")
end

using Test
using EllipsisNotation, Aqua
@testset "Aqua" begin
    Aqua.find_persistent_tasks_deps(EllipsisNotation)
    Aqua.test_ambiguities(EllipsisNotation, recursive = false)
    Aqua.test_deps_compat(EllipsisNotation)
    Aqua.test_piracies(EllipsisNotation)
    Aqua.test_project_extras(EllipsisNotation)
    Aqua.test_stale_deps(EllipsisNotation)
    Aqua.test_unbound_args(EllipsisNotation)
    Aqua.test_undefined_exports(EllipsisNotation)
end

using AllocCheck
using EllipsisNotation
using Test

@testset "Allocation Tests" begin
    @testset "_ndims_index is allocation-free" begin
        # Test that the core _ndims_index function doesn't allocate
        # This is the key internal function for computing number of dimensions

        # Simple cases
        @check_allocs function test_ndims_simple()
            EllipsisNotation._ndims_index((1,))
        end
        @test test_ndims_simple() == 1

        @check_allocs function test_ndims_with_ellipsis()
            EllipsisNotation._ndims_index((..,))
        end
        @test test_ndims_with_ellipsis() == 1

        @check_allocs function test_ndims_mixed()
            EllipsisNotation._ndims_index((.., 1, 2))
        end
        @test test_ndims_mixed() == 3

        @check_allocs function test_ndims_empty()
            EllipsisNotation._ndims_index(())
        end
        @test test_ndims_empty() == 0
    end
end

@test isempty(detect_ambiguities(EllipsisNotation))

A = Array{Int}(undef, 2, 4, 2)

A[.., 1] = [2 1 4 5
    2 2 3 6]

A[.., 2] = [3 2 6 5
    3 2 6 6]

@test A[:, :, 1] == [2 1 4 5
    2 2 3 6]

@test A[:, :, 2] == [3 2 6 5
    3 2 6 6]

@test A[:, .., 1] == [2 1 4 5
    2 2 3 6]

@test A[:, .., 1] == [2 1 4 5
    2 2 3 6]

A[1, ..] = reshape([3 4
        5 6
        4 5
        6 7],
    1,
    4,
    2)

B = [3 4
    5 6
    4 5
    6 7]

@test B == reshape(A[1, ..], 4, 2) == reshape(view(A, 1, ..), 4, 2)

@test A[:, 1, 2] == A[.., 1, 2] == @view A[.., 1, 2]

# [..]
C = zero(B)
C[:] = B[..]
@test B == C
C[1, 1] += 1
@test B != C

C = zero(B)
C[..] = B[..]
@test B == C
C[1, 1] += 1
@test B != C

C = zero(B)
C[..] .= B[:]
@test B == C
C[1, 1] += 1
@test B != C

C = zero(B)
C[..] .= B[..]
@test B == C
C[1, 1] += 1
@test B != C

@test B[:] == B[..]
@test B[:] !== B[..]

@testset "StaticArrayInterface" begin
    A = Array{Int}(undef, 2, 4, 2)
    StaticArrayInterface.setindex!(A, [2 1 4 5; 2 2 3 6], .., 1)
    StaticArrayInterface.setindex!(A, [3 2 6 5; 3 2 6 6], .., 2)

    @test StaticArrayInterface.getindex(A, :, :, 1) == [2 1 4 5; 2 2 3 6]
    @test StaticArrayInterface.getindex(A, :, :, 2) == [3 2 6 5; 3 2 6 6]

    @test StaticArrayInterface.getindex(A, :, .., 1) == [2 1 4 5; 2 2 3 6]
    @test StaticArrayInterface.getindex(A, :, .., 2) == [3 2 6 5; 3 2 6 6]

    StaticArrayInterface.setindex!(A, reshape([3 4; 5 6; 4 5; 6 7], 1, 4, 2), 1, ..)

    B = [3 4
        5 6
        4 5
        6 7]

    @test B ==
          reshape(StaticArrayInterface.getindex(A, 1, ..), 4, 2) ==
          reshape(view(A, 1, ..), 4, 2)

    @test A[:, 1, 2] == StaticArrayInterface.getindex(A, .., 1, 2)

    # [..]
    C = zero(B)

    C[:] = StaticArrayInterface.getindex(B, ..)
    @test B == C
    C[1, 1] += 1
    @test B != C

    StaticArrayInterface.setindex!(C, StaticArrayInterface.getindex(B, ..), ..)
    @test B == C
    C[1, 1] += 1
    @test B != C
end

using Test
using EllipsisNotation
@testset "CartesianIndex" begin
    A = rand(4, 4, 4, 4, 4)
    @test A[.., 1, 2, 3] == A[.., CartesianIndex(1, 2, 3)]
    @test A[1, .., 2, 3] == A[CartesianIndex(1), .., CartesianIndex(2, 3)]
    @test A[1, 2, .., 3] == A[CartesianIndex(1, 2), .., CartesianIndex(3)]

    @test A[.., 1:1, 2:2, 1:3] == A[.., CartesianIndices((1:1, 2:2, 1:3))]
    @test A[1:1, .., 2:2, 1:3] == A[1:1, .., CartesianIndices((2:2, 1:3))]
    @test A[1:2, 2, .., 1:3] == A[CartesianIndices((1:2,)), 2, .., CartesianIndices((1:3))]
end

using Test
using EllipsisNotation
using StaticArrayInterface: StaticArrayInterface

# Exercises the EllipsisNotationStaticArrayInterfaceExt extension: `..` working
# through StaticArrayInterface's own getindex/setindex!.
@testset "StaticArrayInterface" begin
    A = Array{Int}(undef, 2, 4, 2)
    StaticArrayInterface.setindex!(A, [2 1 4 5; 2 2 3 6], .., 1)
    StaticArrayInterface.setindex!(A, [3 2 6 5; 3 2 6 6], .., 2)

    @test StaticArrayInterface.getindex(A, :, :, 1) == [2 1 4 5; 2 2 3 6]
    @test StaticArrayInterface.getindex(A, :, :, 2) == [3 2 6 5; 3 2 6 6]

    @test StaticArrayInterface.getindex(A, :, .., 1) == [2 1 4 5; 2 2 3 6]
    @test StaticArrayInterface.getindex(A, :, .., 2) == [3 2 6 5; 3 2 6 6]

    StaticArrayInterface.setindex!(A, reshape([3 4; 5 6; 4 5; 6 7], 4, 2), 1, ..)

    B = [
        3 4
        5 6
        4 5
        6 7
    ]

    @test B ==
        reshape(StaticArrayInterface.getindex(A, 1, ..), 4, 2) ==
        reshape(view(A, 1, ..), 4, 2)

    @test A[:, 1, 2] == StaticArrayInterface.getindex(A, .., 1, 2)

    # [..]
    C = zero(B)

    C[:] = StaticArrayInterface.getindex(B, ..)
    @test B == C
    C[1, 1] += 1
    @test B != C

    StaticArrayInterface.setindex!(C, StaticArrayInterface.getindex(B, ..), ..)
    @test B == C
    C[1, 1] += 1
    @test B != C
end

module EllipsisNotation

using PrecompileTools: @compile_workload, @setup_workload

import Base: to_indices, tail

struct Ellipsis end

"""
Implementation of the notation `..` for indexing arrays. It's similar to the Python
`...` in that it means 'all the columns before (or after)'.

`..` slurps dimensions greedily, meaning that the first occurrence
of `..` in an index expression creates as many slices as possible. Other
instances of `..` afterward are treated simply as slices. Usually, you
should only use one instance of `..` in an indexing expression to avoid
possible confusion.

# Example

```jldoctest
julia> A = Array{Int}(undef, 2, 4, 2);

julia> A[.., 1] = [2 1 4 5
                   2 2 3 6];

julia> A[.., 2] = [3 2 6 5
                   3 2 6 6];

julia> A[:, :, 1] == [2 1 4 5
                      2 2 3 6]
true

julia> A[1, ..] = reshape([3 4
                           5 6
                           4 5
                           6 7], 1, 4, 2) # drops singleton dimension
...

julia> B = [3 4
            5 6
            4 5
            6 7];

julia> B == reshape(A[1, ..], 4, 2)
true
```
"""
const .. = Ellipsis()

@inline function to_indices(
        A,
        inds::NTuple{M, Any},
        I::Tuple{Ellipsis, Vararg{Any, N}}
    ) where {M, N}
    # Align the remaining indices to the tail of the `inds`. `Val` keeps the
    # number of inserted colons in the type domain so the result is type stable.
    colons = ntuple(Returns(Colon()), Val(M - _ndims_index(I) + 1))
    return to_indices(A, inds, (colons..., tail(I)...))
end

# Number of array dimensions consumed by a tuple of indices. Most index types
# consume a single dimension; the exceptions below consume several at once.
@inline _ndims_index(inds::Tuple{}) = 0
@inline _ndims_index(inds::Tuple) = _ndims_index1(inds[1]) + _ndims_index(tail(inds))

@inline _ndims_index1(::Any) = 1
@inline _ndims_index1(::CartesianIndex{N}) where {N} = N
@inline _ndims_index1(::AbstractArray{Bool, N}) where {N} = N
@inline _ndims_index1(::AbstractArray{<:CartesianIndex{N}}) where {N} = N
@inline _ndims_index1(::Ellipsis) = 1

export ..

@setup_workload begin
    @compile_workload begin
        # Precompile common ellipsis indexing patterns for Float64 arrays
        # 2D arrays
        A2 = zeros(2, 3)
        A2[.., 1]
        A2[1, ..]

        # 3D arrays (most common use case)
        A3 = zeros(2, 3, 4)
        A3[.., 1]
        A3[1, ..]
        A3[:, .., 1]
        A3[1, .., 2]

        # 4D arrays
        A4 = zeros(2, 3, 4, 5)
        A4[.., 1]
        A4[1, ..]
        A4[.., 1, 2]
        A4[1, 2, ..]

        # 5D arrays
        A5 = zeros(2, 3, 4, 5, 6)
        A5[.., 1]
        A5[1, ..]

        # Int64 arrays (common in indexing operations)
        B3 = zeros(Int, 2, 3, 4)
        B3[.., 1]
        B3[1, ..]

        B4 = zeros(Int, 2, 3, 4, 5)
        B4[.., 1]
        B4[1, ..]

        # Float32 arrays (common in GPU/ML workloads)
        C3 = zeros(Float32, 2, 3, 4)
        C3[.., 1]
        C3[1, ..]

        C4 = zeros(Float32, 2, 3, 4, 5)
        C4[.., 1]
        C4[1, ..]
    end

    # Explicit precompile statements to force native code caching
    # These are needed because getindex/setindex!/to_indices are Base methods
    # and their specializations may not be cached in the package image otherwise

    # Common getindex patterns
    for T in (Float64, Float32, Int)
        # 2D
        precompile(getindex, (Array{T, 2}, Ellipsis, Int))
        precompile(getindex, (Array{T, 2}, Int, Ellipsis))

        # 3D - most common use case
        precompile(getindex, (Array{T, 3}, Ellipsis, Int))
        precompile(getindex, (Array{T, 3}, Int, Ellipsis))
        precompile(getindex, (Array{T, 3}, Colon, Ellipsis, Int))
        precompile(getindex, (Array{T, 3}, Int, Ellipsis, Int))

        # 4D
        precompile(getindex, (Array{T, 4}, Ellipsis, Int))
        precompile(getindex, (Array{T, 4}, Int, Ellipsis))
        precompile(getindex, (Array{T, 4}, Ellipsis, Int, Int))
        precompile(getindex, (Array{T, 4}, Int, Int, Ellipsis))

        # 5D
        precompile(getindex, (Array{T, 5}, Ellipsis, Int))
        precompile(getindex, (Array{T, 5}, Int, Ellipsis))
    end

    # Common setindex! patterns
    for T in (Float64, Float32, Int)
        # 3D
        precompile(setindex!, (Array{T, 3}, Array{T, 2}, Ellipsis, Int))
        precompile(setindex!, (Array{T, 3}, Array{T, 2}, Int, Ellipsis))

        # 4D
        precompile(setindex!, (Array{T, 4}, Array{T, 3}, Ellipsis, Int))
        precompile(setindex!, (Array{T, 4}, Array{T, 3}, Int, Ellipsis))
    end
end

end # module

using SciMLTesting, EllipsisNotation, Test
using JET

# ExplicitImports only sees an extension module once its trigger package is loaded,
# so load the weakdeps here to get EllipsisNotationStaticArrayInterfaceExt scanned.
using StaticArrayInterface

run_qa(EllipsisNotation)

@testset "JET type stability" begin
    @testset "_ndims_index" begin
        @test_opt EllipsisNotation._ndims_index(())
        @test_opt EllipsisNotation._ndims_index((1,))
        @test_opt EllipsisNotation._ndims_index((1, 2, 3))
        @test_opt EllipsisNotation._ndims_index((..,))
        @test_opt EllipsisNotation._ndims_index((.., 1, 2))
    end

    @testset "array indexing" begin
        A3 = zeros(2, 3, 4)
        @test_call A3[.., 1]
        @test_call A3[1, ..]
        @test_call A3[:, .., 1]
        @test_call A3[1, .., 2]

        A4 = zeros(2, 3, 4, 5)
        @test_call A4[.., 1]
        @test_call A4[1, ..]
        @test_call A4[.., 1, 2]
        @test_call A4[1, 2, ..]
    end
end

module EllipsisNotationStaticArrayInterfaceExt

using ArrayInterface: ArrayInterface
using EllipsisNotation: Ellipsis
using Static: static
using StaticArrayInterface: StaticArrayInterface

# Integrate `..` with StaticArrayInterface's indexing machinery so that `..`
# works through `StaticArrayInterface.getindex` / `setindex!`. `ndims_index` is
# owned by ArrayInterface and `static` by Static; StaticArrayInterface merely
# re-exports them, so both are taken from their owners. StaticArrayInterface
# depends on both, so loading it still activates this extension.
StaticArrayInterface.is_splat_index(::Type{Ellipsis}) = static(true)
ArrayInterface.ndims_index(::Type{Ellipsis}) = static(1)
function StaticArrayInterface.to_index(x, ::Ellipsis)
    return ntuple(i -> StaticArrayInterface.indices(x, i), Val(ndims(x)))
end

end

using ExplicitImports
using EllipsisNotation
using Test

@testset "ExplicitImports" begin
    @test check_no_implicit_imports(EllipsisNotation) === nothing
    @test check_no_stale_explicit_imports(EllipsisNotation) === nothing
end

# EllipsisNotation.jl

**EllipsisNotation.jl** implements the notation `..` for indexing arrays. It's similar to the Python
`...` in that it means 'all the columns before (or after)'.

`..` slurps dimensions greedily, meaning that the first occurrence
of `..` in an index expression creates as many slices as possible. Other
instances of `..` afterward are treated simply as slices. Usually, you
should only use one instance of `..` in an indexing expression to avoid
possible confusion.

## Installation

```julia
using Pkg
Pkg.add("EllipsisNotation")
using EllipsisNotation
```

## Example Usage

```julia
julia> A = Array{Int}(undef, 2, 4, 2)

julia> A[.., 1] = [2 1 4 5
                   2 2 3 6]

julia> A[.., 2] = [3 2 6 5
                   3 2 6 6]

julia> A[:, :, 1] == [2 1 4 5
                      2 2 3 6]
true

julia> A[1, ..] = reshape([3 4
                           5 6
                           4 5
                           6 7], 1, 4, 2) # drops singleton dimension

julia> B = [3 4
            5 6
            4 5
            6 7]

julia> B == reshape(A[1, ..], 4, 2)
true

julia> A[.., 1, 2] # Can do as many integers as you want on the end!

```

For avoiding squeezing dimensions from slicing.

```julia
julia> C = ones(3, 3, 3, 3, 3);

julia> size(C[1:1, .., 1:1])
(1, 3, 3, 3, 1)
```

Note: `..` slurps dimensions greedily, meaning that the first occurrence
of `..` in an index expression creates as many slices as possible. Other
instances of `..` afterwards are treated simply as slices. Usually, you
should only use one instance of `..` in an indexing expression to avoid
possible confusion.

**Warning:** `..` does not work when indexing also with `end` or `begin`.
For example, `A = randn(2,3,4); A[.., 1:end]` will not give the intended
result. This is a known limitation, and is not likely to be fixed until
some necessary changes in the Julia language itself are implemented. See
https://github.com/ChrisRackauckas/EllipsisNotation.jl/issues/19
for more details.

## Contributing

  - Please refer to the
    [SciML ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://github.com/SciML/ColPrac/blob/master/README.md)
    for guidance on PRs, issues, and other matters relating to contributing to SciML.

  - See the [SciML Style Guide](https://github.com/SciML/SciMLStyle) for common coding practices and other style decisions.
  - There are a few community forums:
    
      + The #diffeq-bridged and #sciml-bridged channels in the
        [Julia Slack](https://julialang.org/slack/)
      + The #diffeq-bridged and #sciml-bridged channels in the
        [Julia Zulip](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
      + On the [Julia Discourse forums](https://discourse.julialang.org)
      + See also [SciML Community page](https://sciml.ai/community/)

## Acknowledgements

I would like to acknowledge M. Schauer for the `..` notation implementation.
He had the original idea, I just extended it and put it into a package because
of how useful it has been to me.

## Reproducibility

```@raw html
<details><summary>The documentation of this SciML package was built using these direct dependencies,</summary>
```

```@example
using Pkg # hide
Pkg.status() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>and using this machine and Julia version.</summary>
```

```@example
using InteractiveUtils # hide
versioninfo() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>A more complete overview of all dependencies and their versions is also provided.</summary>
```

```@example
using Pkg # hide
Pkg.status(; mode = PKGMODE_MANIFEST) # hide
```

```@raw html
</details>
```

```@eval
using TOML
using Markdown
version = TOML.parse(read("../../Project.toml", String))["version"]
name = TOML.parse(read("../../Project.toml", String))["name"]
link_manifest = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
                "/assets/Manifest.toml"
link_project = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
               "/assets/Project.toml"
Markdown.parse("""You can also download the
[manifest]($link_manifest)
file and the
[project]($link_project)
file.
""")
```
